SUB ExecCgi(CgiProgram AS STRING, HeadQuery AS BYTE)
  DIM AS STRING DateHeader, ServerHeader, LineBuff, Parameters, TempString
  DIM AS INTEGER CgiHandler, IntCounter, ResOk
  DIM AS UINTEGER bytesread
  DIM ByteBuff AS STRING*1
  DIM AS BYTE HeaderDone, NphScript

  DateHeader = "Date: " + GetRFC1123time(NowGMT())
  ServerHeader = "Server: Grumpy/" + pVer
  IF LEN(SrvSideParams) > 0 AND INSTR(SrvSideParams, "=") = 0 THEN
    Parameters = " "
    FOR IntCounter = 1 TO LEN(SrvSideParams)
      IF MID(SrvSideParams, IntCounter, 1) <> "&" AND MID(SrvSideParams, IntCounter, 1) <> ";" THEN
          Parameters += MID(SrvSideParams, IntCounter, 1)
        ELSE
          Parameters += " "
      END IF
    NEXT IntCounter
  END IF
  Parameters = TranslatePercentEnc(Parameters)        ' Decode % encoding for command-line params
  REM Check wheter it's a NPH script
  IntCounter = LEN(CgiProgram)                                             '
  DO                                                                       '  Check for
    IntCounter -= 1                                                        '  NPH script
  LOOP UNTIL MID(CgiProgram, IntCounter, 1) = DirSlash OR IntCounter = 1   '
  IF LCASE(MID(CgiProgram, IntCounter + 1, 4)) = "nph-" THEN NphScript = 1 '


  IF VerboseMode > 0 THEN
    IF NphScript = 1 THEN
        LogLine("Response: Exec NPH-CGI " + CHR(34) + CgiProgram + Parameters + CHR(34))
      ELSE
        LogLine("Response: 200 OK (Exec CGI " + CHR(34) + CgiProgram + Parameters + CHR(34) + ")")
    END IF
  END IF

  REM  ** Set all HTTP-related CGI environment variables **
  IF LEN(HostBuff) > 0 THEN SetEnv("SERVER_NAME=" + HostBuff)            ' The server's hostname, DNS alias, or IP address as it would appear in self-referencing URLs.
  SetEnv("SERVER_SOFTWARE=Grumpy/" + pVer)                               ' The name and version of the server software. Format: name/version
  SetEnv("GATEWAY_INTERFACE=CGI/1.0")                                    ' The revision of the CGI specification to which this server complies. Format: CGI/revision (typically CGI/1.0 or CGI/1.1)
  IF LEN(SrvSideParams) > 0 THEN SetEnv("QUERY_STRING=" + SrvSideParams) ' QUERY_STRING should not be decoded in any fashion!
  IF LEN(UserAgentBuff) > 0 THEN SetEnv("HTTP_USER_AGENT=" + UserAgentBuff)
  IF LEN(GetQuery) > 0 THEN SetEnv("REQUEST_METHOD=" + GetQuery)
  IF LEN(GetParam2) > 0 THEN
    SetEnv("HTTP_VERSION=" + GetParam2)
    SetEnv("SERVER_PROTOCOL=" + GetParam2)
  END IF
  IF LEN(CookieBuff) > 0 THEN SetEnv("HTTP_COOKIE=" + CookieBuff)
  IF LEN(RefererBuff) > 0 THEN SetEnv("HTTP_REFERER=" + RefererBuff)
  IF LEN(AuthorizationBuff) > 0 THEN
    IF UCASE(MID(AuthorizationBuff, 1, 5)) = "BASIC" THEN TempString = "BASIC"
    IF UCASE(MID(AuthorizationBuff, 1, 6)) = "DIGEST" THEN TempString = "DIGEST"
    'SetEnv("AUTH_USER=" + AuthUser)
    'SetEnv("REMOTE_USER=" + AuthUser)
    SetEnv("AUTH_TYPE=" + TempString)
  END IF
  IF LEN(GetParam1) > 0 THEN SetEnv("SCRIPT_NAME=" + GetParam1)
  REM  ** Environment variables set. **

  CgiHandler = FREEFILE
'  OPEN PIPE CgiProgram + Parameters FOR BINARY ACCESS READ AS #CgiHandler
  OPEN PIPE CgiProgram + Parameters FOR INPUT AS #CgiHandler

  IF NphScript = 0 THEN    ' If not NPH script, then parse the header
    PRINT "HTTP/1.1 200 OK"; CRLF;
    HeaderDone = 0
    WHILE HeaderDone = 0 AND NOT EOF(CgiHandler)
      LINE INPUT #CgiHandler, LineBuff
      IF LineBuff = "" THEN
          HeaderDone = 1
        ELSE
          IF UCASE(LEFT(LineBuff, 7)) = "SERVER:" THEN ServerHeader = ""
          IF UCASE(LEFT(LineBuff, 5)) = "DATE:" THEN DateHeader = ""
          PRINT LineBuff; CRLF;
      END IF
    WEND

'    WHILE HeaderDone = 0 AND NOT EOF(CgiHandler)
'      GET #CgiHandler,, ByteBuff
'      IF ByteBuff <> CHR(13) AND ByteBuff <> CHR(10) THEN LineBuff += ByteBuff
'      IF ByteBuff = CHR(10) THEN
'        IF LEN(LineBuff) > 0 THEN PRINT LineBuff; CRLF;
'        IF UCASE(LEFT(LineBuff, 7)) = "SERVER:" THEN ServerHeader = ""
'        IF UCASE(LEFT(LineBuff, 5)) = "DATE:" THEN DateHeader = ""
'        IF LineBuff = "" THEN HeaderDone = 1 ELSE LineBuff = ""
'      END IF
'    WEND

    IF LEN(DateHeader) > 0 THEN PRINT DateHeader; CRLF;
    IF LEN(ServerHeader) > 0 THEN PRINT ServerHeader; CRLF;
    PRINT "Connection: close"; CRLF;
    'PRINT "Allow: GET, HEAD"; CRLF;
    'PRINT "Accept-Ranges: bytes"; CRLF;
    'PRINT "Content-Length: 8700"; CRLF;
    'PRINT "Content-Type: text/html; charset=UTF-8"; CRLF;
    PRINT CRLF;
  END IF

  WHILE NOT EOF(CgiHandler)
    LINE INPUT #CgiHandler, TempString
    PRINT TempString + CRLF;
  WEND

'  bytesread = 1
'  IF HeadQuery = 0 THEN
'    WHILE bytesread > 0
'      PRINT "-";
'      ResOk = GET(#CgiHandler,, ByteBuff,,bytesread)
'      PRINT ByteBuff;
'    WEND
'  END IF
  CLOSE #CgiHandler
END SUB
