REM
REM This file is part of the Grumpy project
REM Copyright (C) Mateusz Viste 2008-2010
REM


FUNCTION ReadLangCFG(CFGfile AS STRING, CFGField AS STRING) AS STRING
 DIM AS STRING CfgReturnString, CfgTmpBuffer, TokenValue, TokenName
 DIM AS UINTEGER Counter
 DIM AS INTEGER CfgFileHandler, CfgColonPos
 CfgFileHandler = FREEFILE
 CfgReturnString = ""
 Counter = 0
 IF DIR(CFGfile) <> "" THEN
   OPEN CFGfile FOR INPUT AS #CfgFileHandler
   DO
      Counter += 1
      LINE INPUT #CfgFileHandler, CfgTmpBuffer
      CfgTmpBuffer = CheckTrimBOM(CfgTmpBuffer)
      IF MID(TRIM(CfgTmpBuffer), 1, 1) <> "#" THEN
        CfgColonPos = INSTR(CfgTmpBuffer, "=")
        TokenName = TRIM(MID(CfgTmpBuffer, 1, CfgColonPos - 1))
        TokenValue = TRIM(MID(CfgTmpBuffer, CfgColonPos + 1))
        IF TokenName = CFGField THEN CfgReturnString = TokenValue
      END IF
   LOOP UNTIL EOF(CfgFileHandler) OR (Counter = 100000)
   CLOSE #CfgFileHandler
 END IF
 RETURN CfgReturnString
END FUNCTION


FUNCTION CheckForLangNego(LocalFile AS STRING, AcceptLangBuff AS STRING) AS STRING
  REM This function takes a local file (LocalFile) as well as a list of preferred languages, and
  REM checks if there is a better file for the user, and returns that file (returns nothing otherwise).

  IF LEN(AcceptLangBuff) > 0 THEN
      DIM AS STRING Result = "", LangConfigFile, OrgShortFile, PrefLang
      LangConfigFile = LEFT(LocalFile, INSTRREV(LocalFile, DirSlash)) & "grumpy.lang"
      OrgShortFile = MID(LocalFile, INSTRREV(LocalFile, DirSlash) + 1)
      PrefLang = LCASE(LEFT(AcceptLangBuff, 2))

      IF FileExists(LangConfigFile) <> 0 THEN
        Result = ReadLangCFG(LangConfigFile, OrgShortFile & ":" & PrefLang)
        IF (Result = LocalFile) OR (Result = OrgShortFile) THEN
          Result = ""  ' Avoid obvious loops due to bad user configuration
          IF VerboseMode > 0 THEN
            LogLine("ERROR: bad lang configuration in " & LangConfigFile & "! " & OrgShortFile & " for lang [" & PrefLang & "] is trying to redirect to itself!")
          END IF
        END IF
        IF LEN(Result) > 0 THEN
            IF (VerboseMode > 0) THEN
              LogLine("Found better file for lang [" & PrefLang & "] -> redirecting to " & Result)
            END IF
          ELSE
            IF (VerboseMode > 1) THEN
              LogLine("No better file found for lang [" & PrefLang & "]")
            END IF
        END IF
      END IF
      RETURN Result
    ELSE
      RETURN ""
  END IF
END FUNCTION
