REM
REM This file is part of the Grumpy Server project.
REM http://www.viste-family.net/mateusz/software/grumpy/
REM Author: Mateusz Viste
REM

SUB ListDir(DirectoryToList AS STRING, HeadFlag AS BYTE = 0)
  DIM AS STRING FileName, ListTitle, EntryStyle, EntrySize, EntryDescription, LinkDescription, TitleLinkParameter
  DIM AS STRING ConnBuffer = ""
  DIM AS UINTEGER FileAttrib
  DIM AS INTEGER DirIndex, x, y, SmallestEntry, BufferOverflow = 0
  DIM AS DOUBLE StartTime
  DIM AS BYTE EntryIsADir
  DIM DirList(1 TO 20000) AS STRING
  IF VerboseMode > 0 THEN LogLine("Response: 200 OK (list directory """ + DirectoryToList + """)")
  ListTitle = MID(DirectoryToList, LEN(RootPath))
  #IFDEF __FB_WIN32__
    ListTitle = BackslashToSlash(ListTitle)
  #ENDIF
  EntryDescription = TRIM(GetFileDescription(".", DirectoryToList))
  IF LEN(EntryDescription) > 0 THEN EntryDescription = HtmlizeText(EntryDescription)
  StartTime = TIMER
  PRINT GetParam2 + " 200 OK" + CRLF;
  IF HeadFlag = 0 THEN
    ConnBuffer += "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01//EN"" ""http://www.w3.org/TR/html4/strict.dtd"">" + CRLF
    ConnBuffer += "<html>" + CRLF
    ConnBuffer += "  <head>" + CRLF
    IF LEN(EntryDescription) > 0 THEN
        ConnBuffer += "    <title>" + EntryDescription + "</title>" + CRLF
      ELSE
        ConnBuffer += "    <title>Index of " + ListTitle + "</title>" + CRLF
    END IF
    ConnBuffer += "    <meta name=""Generator"" content=""Grumpy web server v" + pVer + """>" + CRLF
    ConnBuffer += "    <meta http-equiv=""Content-Type"" content=""text/html; charset=utf-8"">" + CRLF
    IF LEN(DirListCSS) = 0 THEN
        ConnBuffer += "    <style type=""text/css"">" + CRLF
        ConnBuffer += "      body {" + CRLF
        ConnBuffer += "        color: #000000;" + CRLF
        ConnBuffer += "        background-color: #DADAFF;" + CRLF
        ConnBuffer += "        margin: 1em 0.5em 1em 0.5em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      a:link    {color: #0505FF}" + CRLF
        ConnBuffer += "      a:visited {color: #0000DF}" + CRLF
        ConnBuffer += "      a:active  {color: #0000FF}" + CRLF
        ConnBuffer += "      a:hover   {color: #4040FF}" + CRLF
        ConnBuffer += "      table.ContentTable {" + CRLF
        ConnBuffer += "        padding: 0;" + CRLF
        ConnBuffer += "        border-spacing: 0;" + CRLF
        ConnBuffer += "        width: 100%;" + CRLF
        ConnBuffer += "        background-color: #EAEAFF;" + CRLF
        ConnBuffer += "        border: 1px solid #000000;" + CRLF
        ConnBuffer += "        margin: 0 0 0 0;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.CurrentURL {" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0 0.5em;" + CRLF
        ConnBuffer += "        font-weight: bold;" + CRLF
        ConnBuffer += "        font-size: 1.2em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.DescriptionURL {" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "        font-style: italic;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.ErrorMsg {" + CRLF
        ConnBuffer += "        background-color: #D00000;" + CRLF
        ConnBuffer += "        font-weight: bold;" + CRLF
        ConnBuffer += "        text-align: center;" + CRLF
        ConnBuffer += "        color: #FFFF20;" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.EmptyDirectoryMsg {" + CRLF
        ConnBuffer += "        background-color: #E1E1FA;" + CRLF
        ConnBuffer += "        font-weight: bold;" + CRLF
        ConnBuffer += "        text-align: center;" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.ColHeaders {" + CRLF
        ConnBuffer += "        background-color: #C2C2EF;" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "        font-weight: bold;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.DarkEntry {" + CRLF
        ConnBuffer += "        background-color: #E1E1FA;" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.LightEntry {" + CRLF
        ConnBuffer += "        background-color: #EAEAFF;" + CRLF
        ConnBuffer += "        padding: 0.1em 0.5em 0.1em 0.5em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      table.FooterTable {" + CRLF
        ConnBuffer += "        width: 100%;" + CRLF
        ConnBuffer += "        border: 0;" + CRLF
        ConnBuffer += "        padding: 0;" + CRLF
        ConnBuffer += "        margin: 0 0 0 0;" + CRLF
        ConnBuffer += "        border-spacing: 0;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.FooterLeft {" + CRLF
        ConnBuffer += "        text-align: left;" + CRLF
        ConnBuffer += "        color: #404040;" + CRLF
        ConnBuffer += "        font-size: 0.8em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      td.FooterRight {" + CRLF
        ConnBuffer += "        text-align: right;" + CRLF
        ConnBuffer += "        color: #404040;" + CRLF
        ConnBuffer += "        font-size: 0.8em;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "      a.HomepageLink {" + CRLF
        ConnBuffer += "        color: #404040;" + CRLF
        ConnBuffer += "        text-decoration: none;" + CRLF
        ConnBuffer += "      }" + CRLF
        ConnBuffer += "    </style>" + CRLF
      ELSE
        ConnBuffer += "    <link rel=""Stylesheet"" type=""text/css"" href=""" + DirListCSS +""">" + CRLF
    END IF
    ConnBuffer += "  </head>" + CRLF
    ConnBuffer += "  <body>" + CRLF
    ConnBuffer += "    <table class=""ContentTable"">" + CRLF
    ConnBuffer += "      <tr>" + CRLF
    ConnBuffer += "        <td class=""CurrentURL"" colspan=""4"">"
    IF LEN(HostBuff) > 0 THEN
        IF LEN(HostPortBuff) > 0 THEN
            ConnBuffer += "http://" + HostBuff + ":" + HostPortBuff + ListTitle
          ELSE
            ConnBuffer += "http://" + HostBuff + ListTitle
        END IF
      ELSE ' If no HOST has been provided (HTTP/1.0)...
        ConnBuffer += ListTitle
    END IF
    ConnBuffer += "</td>" + CRLF
    ConnBuffer += "      </tr>" + CRLF
    ConnBuffer += "      <tr>" + CRLF
    ConnBuffer += "        <td class=""DescriptionURL"" colspan=""4"">"
    IF LEN(EntryDescription) > 0 THEN ConnBuffer += EntryDescription ELSE ConnBuffer += "&nbsp;"
    ConnBuffer += "</td>" + CRLF
    ConnBuffer += "      </tr>" + CRLF

    FileName = DIR(DirectoryToList + "*", &h37, FileAttrib)
    DirIndex = 0
    WHILE FileName <> "" AND DirIndex < 20000
      IF FileName <> "." AND (FileName <> ".." OR DirectoryToList <> RootPath) AND (LEFT(FileName, 1) <> "." OR FileName = "..") AND Filename <> "descript.ion" THEN
        DirIndex += 1
        DirList(DirIndex) = FileName
        IF FileAttrib AND &h10 THEN DirList(DirIndex) = CHR(9) + DirList(DirIndex)
      END IF
      FileName = DIR(FileAttrib)
    WEND

  REM  ***  Here I am sorting the directory's entries ***
    IF DirIndex > 1 THEN strQsort(DirList(), DirIndex)  ' (included in sortstr.bi)

  REM  ***  Now, we will display all entries
    ConnBuffer += "      <tr>" + CRLF
    ConnBuffer += "        <td class=""ColHeaders"">Name</td>" + CRLF
    ConnBuffer += "        <td class=""ColHeaders"">Size</td>" + CRLF
    ConnBuffer += "        <td class=""ColHeaders"">Date&nbsp;/&nbsp;Time</td>" + CRLF
    ConnBuffer += "        <td class=""ColHeaders"">Description</td>" + CRLF
    ConnBuffer += "      </tr>" + CRLF
    IF LEN(FileName) > 0 THEN
      ConnBuffer += "      <tr>" + CRLF
      ConnBuffer += "        <td class=""ErrorMsg"" colspan=""4"">Warning: Too much entries, only 20'000 are displayed!</td>" + CRLF
      ConnBuffer += "      </tr>" + CRLF
    END IF

    IF DirIndex > 0 THEN
        FOR x = 1 TO DirIndex
          IF MID(DirList(x), 1, 1) = CHR(9) THEN
              DirList(x) = MID(DirList(x), 2)
              EntryIsADir = 1
            ELSE
              EntryIsADir = 0
          END IF
          IF x MOD 2 = 0 THEN EntryStyle = "DarkEntry" ELSE EntryStyle = "LightEntry"
          LinkDescription = HtmlizeText(GetFileDescription(DirList(x), DirectoryToList))
          IF LEN(LinkDescription) > 0 THEN TitleLinkParameter = " title=""" + LinkDescription + """" ELSE TitleLinkParameter = ""
          ConnBuffer += "      <tr>" + CRLF
          IF EntryIsADir = 1 THEN
              IF DirList(x) = ".." THEN
                  ConnBuffer += "        <td class=""" + EntryStyle + """>&crarr;&nbsp;<a href=""" + TranslatePercentEnc(GetParentDirectory(ListTitle), 1) + """" + TitleLinkParameter + ">..</a></td>" + CRLF
                ELSE
                  ConnBuffer += "        <td class=""" + EntryStyle + """><a href=""" + SpaceToNbsp(TranslatePercentEnc(DirList(x), 1)) + "/""" + TitleLinkParameter + ">" + HtmlizeText(DirList(x)) + "</a></td>" + CRLF
              END IF
              ConnBuffer += "        <td class=""" + EntryStyle + """>[DIR]</td>" + CRLF
            ELSE
              ConnBuffer += "        <td class=""" + EntryStyle + """><a href=""" + TranslatePercentEnc(DirList(x), 1) + """" + TitleLinkParameter + ">" + HtmlizeText(DirList(x)) + "</a></td>" + CRLF
              ConnBuffer += "        <td class=""" + EntryStyle + """>" + SpaceToNbsp(GetFileSize(DirectoryToList + DirList(x))) + "</td>" + CRLF
          END IF
          ConnBuffer += "        <td class=""" + EntryStyle + """>" + SpaceToNbsp(GetFileDate(DirectoryToList + DirList(x))) + "</td>" + CRLF
          ConnBuffer += "        <td class=""" + EntryStyle + """>" + LinkDescription + "</td>" + CRLF
          ConnBuffer += "      </tr>" + CRLF
          IF LEN(ConnBuffer) > 65536 AND BufferOverflow = 0 THEN   ' If too much data, output the stuff and purge the buffer
            BufferOverflow = 1
            PRINT "Date: " + GetRFC1123time(NowGMT()) + CRLF;
            PRINT "Server: Grumpy/" + pVer + CRLF;
            PRINT "Connection: close" + CRLF;
            PRINT "Allow: GET, HEAD" + CRLF;
            PRINT "Accept-Ranges: bytes" + CRLF;
            'PRINT "Content-Length: " & LEN(ConnBuffer) & CRLF;
            PRINT "Content-Type: text/html; charset=UTF-8" + CRLF;
            IF LEN(xCustomHeaders) > 0 THEN PRINT xCustomHeaders + CRLF;
            PRINT CRLF;
          END IF
          IF BufferOverflow = 1 THEN PRINT ConnBuffer; : ConnBuffer = ""
        NEXT x
      ELSE
        ConnBuffer += "            <tr>" + CRLF
        ConnBuffer += "              <td class=""EmptyDirectoryMsg"" colspan=""4"">This directory is empty.</td>" + CRLF
        ConnBuffer += "            </tr>" + CRLF
    END IF

    ConnBuffer += "    </table>" + CRLF
    ConnBuffer += "    <table class=""FooterTable"">" + CRLF
    ConnBuffer += "      <tr>" + CRLF
    ConnBuffer += "        <td class=""FooterLeft"">Page generated in " & FORMAT(TIMER - StartTime, "#0.000") & "s</td>" + CRLF
    ConnBuffer += "        <td class=""FooterRight""><a href=" + homepage + " class=""HomepageLink"">Grumpy web server v" + pVer + " Copyright &copy; Mateusz Viste " + pDate + "</a></td>" + CRLF
    ConnBuffer += "      </tr>" + CRLF
    ConnBuffer += "    </table>" + CRLF
    ConnBuffer += "  </body>" + CRLF
    ConnBuffer += "</html>" + CRLF
  END IF
  IF BufferOverflow = 0 THEN
    PRINT "Date: " + GetRFC1123time(NowGMT()) + CRLF;
    PRINT "Server: Grumpy/" + pVer + CRLF;
    PRINT "Connection: close" + CRLF;
    PRINT "Allow: GET, HEAD" + CRLF;
    PRINT "Accept-Ranges: bytes" + CRLF;
    PRINT "Content-Length: " & LEN(ConnBuffer) & CRLF;
    PRINT "Content-Type: text/html; charset=UTF-8" + CRLF;
    IF LEN(xCustomHeaders) > 0 THEN PRINT xCustomHeaders + CRLF;
    PRINT CRLF;
  END IF
  IF HeadFlag = 0 THEN PRINT ConnBuffer;
END SUB
